:- ensure_loaded(store_based).
:- ensure_loaded(tests).

negative :-
        do_ntest(test_destrapp),
        do_ntest(test_refapp),
        do_ntest(test_badstoif),
        do_ntest(test_seqpolyrestrict),
        do_ntest(test_incompatif),
        do_ntest(test_pairlistref2),
        do_ntest(test_makerefbad),
        do_ntest(test_lwmakeref1),
        do_ntest(test_lwmakeref2),
        do_ntest(test_garriguepolyfun1),
        do_ntest(test_mklist),
        do_ntest(test_mkupdlist),
        do_ntest(test_mkupdlistbad).

positive :-
        do_test(test_id,
                fun(A, [], A, []),
                []),
        do_test(test_clo,
                fun(fun(Z, [], Z, []), [], fun(X, [], X, []), []),
                []),
        do_test(test_eff,
                fun(fun(Z, [], Z, [(l(_L0),X)]), [], bool, []),
                []),
        do_test(test_app,
                fun(A, [], A, []),
                []),
        do_test(test_absupdint,
                int,
                [(l(_L1), int)]),
        do_test(test_absderef,
                fun(l(L), [(l(L), X)], X, []),
                []),
        do_test(test_cyclicpierce,
                l(L3),
                [ (l(L3), fun(A,
                              [(l(L2), fun(A, _B, C, []))],
                              C,
                              [])),
                  (l(L2), fun(D,
                              [(l(L3), fun(D, _E, F, []))],
                              F,
                              [])) ]),
        do_test(test_cyclicpierceeta,
                fun(_U,[],l(L5),[ (l(L5),fun(V,[],int,[ (l(L4),fun(V,[],int,[]))]))]),
                [ (l(L4),
                   fun(A, [], int,
                       [ (l(L4),fun(A,[],int,[])),
                         (l(L5),fun(A,[],int,[ (l(L4),fun(A,[],int,[]))]))]))]),
        do_test(test_okstoif,
                int,
                [(l(_L6), bool)]),
        do_test(test_infalloc,
                T,
                [ (l(L7), int), (l(L8), fun(int, [ (l(L8), fun(int, [], T, [])) ], T, [ (l(L7), int) ])) ]),
        do_test(test_facknot,
                int,
                [ (l(L9), fun(int, [ (l(L9), fun(int, [], T, [])) ], int, [])) ]),
        do_test(test_fastrevrec,
                list(int),
                [ (l(L12),
                   fun(list(Tau), [ (l(L10), list(int)),
                                      (l(L11), list(int)),
                                      (l(L12), fun(list(Tau), [], list(int), []))],
                       list(int), [])),
                  (l(L11), list(int)),
                  (l(L10), list(int))]),
        do_test(test_fastrevfoldrec,
                fun(fun(A,[],
                        fun(B,[],B,[]),[]),[],
                    fun(B,[],
                        fun(list(A),[],
                            B,[ (l(L13),
                                 fun(list(C),[ (l(L14),list(A)),
                                               (l(L15),B),
                                               (l(L13),fun(list(C),[],B,[]))],
                                     B,[])),
                                (l(L15),B),
                                (l(L14),list(A))]),
                        []),
                    []),
                []),
        do_test(test_foldfast,
                list(bool),
                [ (l(L16),
                   fun(list(T), [ (l(L17), list(bool)),
                                  (l(L18), list(bool)),
                                  (l(L16), fun(list(T), [], list(bool), []))],
                       list(bool), [])),
                  (l(L18), list(bool)),
                  (l(L17), list(bool)) ]),
        do_test(test_garriguepolylist,
                list(T),
                [ (l(_L19), list(T)) ]),
        do_test(test_garriguepolyfun,
                fun(A, [(l(L20), B)], B, []),
                [ (l(L20),list(T)) ]),
        do_test(test_maprec,
                fun(fun(A, [], B, []), [],
                    fun(list(A), [],
                        list(B),
                        [ (l(L21), fun(list(A), [ (l(L21), fun(list(A), [], list(B), [])) ],
                                       list(B), [])) ]), []),
                []),
        do_test(test_letmapid,
                list(bool),
                [ (l(L22), fun(list(bool), [ (l(L22), fun(list(bool), [], list(bool), [])) ],
                               list(bool), [])) ]),
        do_test(test_pairlistref1,
                int,
                [ (l(_L23), list(T)) ]),
        do_test(test_rid,
                int,
                [ (l(_L25), int) ]).

do_test(T, Tau, Sto) :-
        print(T), print(' ... '),
        call(T, P),
        ( infer([], P, [], Tau_, Sto_), Tau_ = Tau, Sto_ = Sto ->
          print('Pass')
        ; print('Fail!') ),
        nl.
do_ntest(T) :-
        print(T), print(' ... '),
        call(T, P),
        ( infer([], P, [], _, _) ->
          print('Fail!')
        ; print('Pass') ),
        nl.

test :-
        print('POSITIVE TESTS'), nl,
        print('**************'), nl,
        positive,
        nl,
        print('NEGATIVE TESTS'), nl,
        print('**************'), nl,
        negative.
